"
 COPYRIGHT (c) 2012-2013 by Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libscm/mercurial' }"

HGRepositoryObject subclass:#HGRemote
	instanceVariableNames:'name url'
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Mercurial-Core'
!

!HGRemote class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2012-2013 by Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!HGRemote methodsFor:'accessing'!

name
    ^ name
!

url
    ^ url
! !

!HGRemote methodsFor:'converting'!

asString
    ^name notNil 
        ifTrue:[name] 
        ifFalse:[url asString].

    "Created: / 29-01-2013 / 15:43:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRemote methodsFor:'displaying'!

displayString
    ^self isDefault ifTrue:[
        name asText allBold , ' - ', url asString
    ] ifFalse:[
        name , ' - ', url asString
    ]

    "Created: / 10-12-2012 / 01:33:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRemote methodsFor:'initialization'!

setName: aString url: aStringOrUrl
    name := aString.
    url := aStringOrUrl asURL

    "Created: / 09-12-2012 / 22:57:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRemote methodsFor:'printing & storing'!

printOn:aStream
    "append a printed representation if the receiver to the argument, aStream"

    super printOn:aStream.
    aStream nextPutAll:'('.
    name printOn:aStream.
    aStream nextPutAll:' - '.
    url printOn:aStream.
    aStream nextPutAll:')'.

    "Modified: / 10-12-2012 / 01:33:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRemote methodsFor:'testing'!

isDefault
    "Return true, if receiver is default remote repository,
     i.e., if default push should go there"

    ^ name = 'default'

    "Created: / 09-12-2012 / 23:24:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRemote class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

